/* (C) Copyright 1984,85,86,87 Walter L. Peacock   All Rights Reserved   */
/* THIS PROGRAM BELONGS TO WALTER L. PEACOCK.  IT IS CONSIDERED A TRADE */
/* SECRET AND IS NOT TO BE DIVULGED OR USED BY PARTIES WHO HAVE NOT   */
/* RECEIVED WRITTEN AUTHORIZATION FROM THE OWNER.                  */

/*---------------------------------------------------------------------------
The prntkeys utility will print index keys, locations, or both to the display.
command line C> prntkeys btreenme x x    <where x is k or l or both for
printing keys and locations.  Default = both>
----------------------------------------------------------------------------*/

/* 09/19/87  P R N T K E Y S . C   Print b+tree keys and/or locations.    */
#include <stdio.h>
#include "cbtree.h"
#include "btfio.h"

#if CI | DC
#else
#include <ctype.h>
#endif

void main(argc, argv)
int argc;
char **argv;
{
	extern	char *strcpy(), *calloc(), *malloc();
	extern int exit();
	extern void free();
	extern long getroot();
        struct btcommo btstruct;
	struct btidxblk *idxblk;
	int moreidx, fdnme, prtkey, prtloc;
	long rootptr, savlvl;
	char  dummy[14];
	register int i;

	prtloc = prtkey = 0;

	if (argc > 2)
	{
		strcpy(dummy, argv[2]);
		if(toupper(dummy[0]) == 'L')
			prtloc = 1;
		else
			prtkey = 1;
		
		if (argc > 3)
		{
			strcpy(dummy, argv[3]);
			if(toupper(dummy[0]) == 'L')
				prtloc = 1;
			else
				prtkey = 1;
		}
	}
	else
		prtloc = prtkey = 1;		/* print both keys and locations. */

	getbname(argc, argv, &btstruct);

	/* open btstruct.idx file   */
	if( (fdnme = bt_open(btstruct.idxname,O_RDONLY) ) == ERR)
		ckerror(- CK_OPEN, "prntkeys");

	i = sizeof(BTIDXBLK) + btstruct.btcells * sizeof(BTIDX);
	if( !(idxblk = (BTIDXBLK *) calloc(i, SZCHAR) ))
		ckerror(- CK_NOMEM, "prntkeys: idxblk");

	idxblk->blkalloc = 0;

	rootptr = getroot(fdnme, btstruct.findroot);  /* get ptr to idx root node */

	getidxr(fdnme, rootptr, idxblk, btstruct.btidxlen, btstruct.btkeylen);
	savlvl = idxblk->btpage[0].btptr;

	while(!idxblk->blktype && savlvl){  /* until data block type = 1 located  */
		getidxr(fdnme, savlvl, idxblk, btstruct.btidxlen, btstruct.btkeylen);
		savlvl = idxblk->btpage[0].btptr;
	}

	/* Make new window */
	wopen("CON:0/0/640/200/Prntkeys");

	moreidx = 1;

	while(moreidx){
		for(i = 0; i < idxblk->cellicnt; i++){
			if (prtloc)
				printf("%7.7ld ", idxblk->btpage[i].btptr);
			if (prtkey)
				printf("%s ", idxblk->btpage[i].skeynme);
			printf("\n");
         }

	if(idxblk->fwdpage > 1){
		getidxr(fdnme, idxblk->fwdpage, idxblk, btstruct.btidxlen, btstruct.btkeylen);
		if(idxblk->fwdpage < 1)
			idxblk->cellicnt--;     /* don't print null cell   */
	}
	else
		moreidx = 0;

	}

	if(idxblk->blkalloc)
		freekeys(idxblk);

	FREE(idxblk);

	close(fdnme);

	btrterm(&btstruct);

	/* close Amiga window */
	wclose();

}
